# This script copies front CSA HW property area region to the back.
# Works with RH850/U2x.

try:
    input = raw_input
except NameError:
    pass

import isystem.connect as ic
from isystem.connect import IConnectDebug

cmgr = ic.ConnectionMgr()
cmgr.connect()

dataCtrl = ic.CDataController(cmgr)

addressFront            = 0xFF320800
addressBack             = 0xFF321000
size                    = 0x800

print("This script will copy Configuration Setting Area front", hex(addressFront), "to back", hex(addressBack), "of size", hex(size))
print("")
input("Press Enter to continue or Ctrl-Break to cancel...")
print("")
memFront = dataCtrl.readMemory(ic.IConnectDebug.fMonitor, 0, addressFront, size, 1)
memFront = memFront[:size]  # remove access info

dataCtrl.writeMemory(ic.IConnectDebug.fMonitor, 0, addressBack, size, 1, memFront)

print("")
print("Done")
input('Press Enter to quit...')

