# This script compares front and back SSA regions of HW property area.
# Works with RH850/U2x.

try:
    input = raw_input
except NameError:
    pass

import isystem.connect as ic
from isystem.connect import IConnectDebug

cmgr = ic.ConnectionMgr()
cmgr.connect()

dataCtrl = ic.CDataController(cmgr)

addressFront            = 0xFF321800
addressBack             = 0xFF322000
size                    = 0x800
displayUnitSizeInBytes  = 4
byteOrder               = "little"

print("Comparing Security Setting Area front", hex(addressFront), "and back", hex(addressBack), "of size", hex(size))
print("")
memFront = dataCtrl.readMemory(ic.IConnectDebug.fMonitor, 0, addressFront, size, 1)
memFront = memFront[:size]  # remove access info

memBack = dataCtrl.readMemory(ic.IConnectDebug.fMonitor, 0, addressBack, size, 1)
memBack = memBack[:size]    # remove access info

# Convert for easier display
memFrontDisplay = []
memBackDisplay = []
for i in range(0, size, displayUnitSizeInBytes):
    memFrontDisplay.append(int.from_bytes(memFront[i:i+displayUnitSizeInBytes], byteOrder, signed=False))
    memBackDisplay.append(int.from_bytes(memBack[i:i+displayUnitSizeInBytes], byteOrder, signed=False))

# Compare
for i in range(len(memFrontDisplay)):
    if memFrontDisplay[i] != memBackDisplay[i]:
        print("Different data in back address:", hex(addressBack + i * displayUnitSizeInBytes), " Front data:", hex(memFrontDisplay[i]), " Back data:", hex(memBackDisplay[i]))

# Compare raw bufer byte to byte
#for i in range(size):
#    if memBack[i] != memFront[i]:
#        print("Different data in back address:", hex(addressBack + i), " Front data:", hex(memFront[i]), " Back data:", hex(memBack[i]))

print("")
print("Done")
input('Press Enter to quit...')
