# This script switches front and back HW property area region.
# Works with RH850/U2x.
# For switching CSA region set CheckCSA to true
# For switching SSA region set CheckSSA to true
# For switching BPA0 region set CheckBPA0 to true
# For switching BPA1 region set CheckBPA1 to true
# (c) TASKING 2022-2024

import isystem.connect as ic

cmgr = ic.ConnectionMgr()
cmgr.connect()

ideCtrl = ic.CIDEController(cmgr)

inParams = ic.StrStrMap()
inParams['DeviceIndex'] = '2'  # RH850/U2x Hardware Property Area of Data flash
inParams['CheckCSA']    = 'true'
inParams['CheckSSA']    = 'false'
inParams['CheckBPA0']   = 'false'
inParams['CheckBPA1']   = 'false'

print("This script will switch Hardware Property Area")
print("")
print("Switching:")
if ('true' == inParams['CheckCSA']) :
  print("- Configuration Settings Area, regular Option bytes")
if ('true' == inParams['CheckSSA']) :
  print("- Security Settings Area\n  This operation can lock your device! Please cancel here to check device values.")
if ('true' == inParams['CheckBPA0']) :
  print("- Block Protection Area for FPSYS0")
if ('true' == inParams['CheckBPA1']) :
  print("- Block Protection Area for FPSYS1")
print("")

input("Press Enter to continue or Ctrl-Break to cancel...")
print("")

print(ideCtrl.invoke("/IOPEN/HW.SoC.RH850G4_HW_Property_Switch", inParams))

print("Done")
input('Press Enter to exit: ')
